;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.8.0 #10562 (Linux)
;--------------------------------------------------------
	.module Horloge
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _pause
	.globl _main
	.globl _heure
	.globl _niv_haut_prec
	.globl _chif_affich
	.globl _cnt
	.globl _chif_defs
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
_chiff_sel	=	0x0048
_segm_sel	=	0x004c
_pio_a_d	=	0x0040
_pio_a_c	=	0x0042
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_cnt	=	0x1000
_chif_affich	=	0x1001
_niv_haut_prec	=	0x1002
_heure	=	0x1003
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:37: void main(void) 
;	---------------------------------
; Function main
; ---------------------------------
_main::
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:39: pio_a_c = 0x4F;                                       // Configurer le port PIO-A en mode entree (mode 0)
	ld	a, #0x4f
	out	(_pio_a_c), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:40: niv_haut_prec = 0;                                    // Initialiser le statut du niveau haut/bas de l'horloge de 1 Hz
	ld	hl,#_niv_haut_prec + 0
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:43: heure[5] = 2;                                         // Dizaine des heure                         
	ld	hl, #(_heure + 0x0005)
	ld	(hl), #0x02
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:44: heure[4] = 3;                                         // Unité des heure                         
	ld	hl, #(_heure + 0x0004)
	ld	(hl), #0x03
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:45: heure[3] = 5;                                         // Dizaine des minutes                   
	ld	hl, #(_heure + 0x0003)
	ld	(hl), #0x05
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:46: heure[2] = 9;                                         // Unité des minutes                     
	ld	hl, #(_heure + 0x0002)
	ld	(hl), #0x09
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:47: heure[1] = 0;                                         // Dizaine des secondes                        
	ld	hl, #(_heure + 0x0001)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:48: heure[0] = 0;                                         // Unité des secondes                           
	ld	hl, #_heure
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:50: while(1)                                              // Boucle principale
00122$:
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:52: if ((pio_a_d & 1) && (!niv_haut_prec))             // Niveau haut sur l'hologe détecté pour la première fois dans la seconde?
	in	a, (_pio_a_d)
	rrca
	jp	NC,00117$
	ld	iy, #_niv_haut_prec
	ld	a, 0 (iy)
	or	a, a
	jp	NZ, 00117$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:54: niv_haut_prec = 1;                              // Lever le fanion du niveau haut détecté
	ld	0 (iy), #0x01
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:55: heure[0]++;                                     // Incrémenter le chiffre d'unités des secondes
	ld	bc, #_heure+0
	ld	a, (bc)
	inc	a
	ld	(bc), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:56: if (heure[0] == 10)                             // Besoin de débordement dans les dizaines de secondes
	ld	a, (#_heure + 0)
	sub	a, #0x0a
	jp	NZ,00118$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:58: heure[0] = 0;
	ld	hl, #_heure
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:59: heure[1]++;                                  // Incrémenter le chiffre de dizaines des secondes
	ld	bc, #_heure+1
	ld	a, (bc)
	inc	a
	ld	(bc), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:60: if (heure[1] == 6)                           // Besoin de débordement dans les unités de minutes
	ld	a, (#(_heure + 0x0001) + 0)
	sub	a, #0x06
	jr	NZ,00118$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:62: heure[1] = 0;
	ld	hl, #(_heure + 0x0001)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:63: heure[2]++;                               // Incrémenter le chiffre d'unités des minutes
	ld	bc, #_heure+2
	ld	a, (bc)
	inc	a
	ld	(bc), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:64: if (heure[2] == 10)                       // Besoin de débordement dans les dizaines de minutes
	ld	a, (#(_heure + 0x0002) + 0)
	sub	a, #0x0a
	jr	NZ,00118$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:66: heure[2] = 0;
	ld	hl, #(_heure + 0x0002)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:67: heure[3]++;                            // Incrémenter le chiffre de dizaines des minutes
	ld	bc, #_heure+3
	ld	a, (bc)
	inc	a
	ld	(bc), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:68: if (heure[3] == 6)                     // Besoin de débordement dans les unités d'heures
	ld	a, (#(_heure + 0x0003) + 0)
	sub	a, #0x06
	jr	NZ,00118$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:70: heure[3] = 0;
	ld	hl, #(_heure + 0x0003)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:71: heure[4]++;                         // Incrémenter le chiffre d'unités des heures
	ld	bc, #_heure+4
	ld	a, (bc)
	inc	a
	ld	(bc), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:72: if (heure[4] == 10)                 // Besoin de débordement dans les dizaines d'heures
	ld	a, (#(_heure + 0x0004) + 0)
	sub	a, #0x0a
	jr	NZ,00102$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:74: heure[4] = 0;
	ld	hl, #(_heure + 0x0004)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:75: heure[5]++;                      // Incrémenter le chiffre de dizaines des heures
	ld	bc, #_heure+5
	ld	a, (bc)
	inc	a
	ld	(bc), a
00102$:
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:77: if ((heure[5] == 2) && (heure[4] == 4))   // 24ème heure atteinte?
	ld	a, (#(_heure + 0x0005) + 0)
	sub	a, #0x02
	jr	NZ,00118$
	ld	a, (#(_heure + 0x0004) + 0)
	sub	a, #0x04
	jr	NZ,00118$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:79: heure[5] = 0;                    // Remettre les heures à 00
	ld	hl, #(_heure + 0x0005)
	ld	(hl), #0x00
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:80: heure[4] = 0;                    //          "
	ld	hl, #(_heure + 0x0004)
	ld	(hl), #0x00
	jr	00118$
00117$:
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:87: else if (!pio_a_d & 1) niv_haut_prec = 0;          // Niveau bas sur l'hologe détecté? Si oui, abaisser le fanion du niveau haut détecté
	in	a, (_pio_a_d)
	sub	a,#0x01
	ld	a, #0x00
	rla
	bit	0, a
	jr	Z,00118$
	ld	hl,#_niv_haut_prec + 0
	ld	(hl), #0x00
00118$:
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:89: for (chif_affich = 0; chif_affich < 6; chif_affich++)    // Boucle d'affichage des 6 chiffres de l'heure
	ld	hl,#_chif_affich + 0
	ld	(hl), #0x00
00125$:
	ld	iy, #_chif_affich
	ld	a, 0 (iy)
	sub	a, #0x06
	jp	NC, 00122$
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:91: segm_sel = chif_defs[heure[chif_affich]];  
	ld	bc, #_heure+0
	ld	hl, (_chif_affich)
	ld	h, #0x00
	add	hl, bc
	ld	c, (hl)
	ld	hl, #_chif_defs
	ld	b, #0x00
	add	hl, bc
	ld	a, (hl)
	out	(_segm_sel), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:92: chiff_sel = ~(0b00000001<<chif_affich);
	ld	b, 0 (iy)
	ld	c, #0x01
	inc	b
	jr	00210$
00209$:
	sla	c
00210$:
	djnz	00209$
	ld	a, c
	cpl
	out	(_chiff_sel), a
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:93: pause();
	call	_pause
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:89: for (chif_affich = 0; chif_affich < 6; chif_affich++)    // Boucle d'affichage des 6 chiffres de l'heure
	ld	hl, #_chif_affich+0
	inc	(hl)
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:96: }
	jr	00125$
_chif_defs:
	.db #0x3f	; 63
	.db #0x06	; 6
	.db #0x5b	; 91
	.db #0x4f	; 79	'O'
	.db #0x66	; 102	'f'
	.db #0x6d	; 109	'm'
	.db #0x7d	; 125
	.db #0x07	; 7
	.db #0x7f	; 127
	.db #0x6f	; 111	'o'
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:99: void pause(void)
;	---------------------------------
; Function pause
; ---------------------------------
_pause::
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:101: for (cnt = 0; cnt < 30; cnt++);     // Boucle basse du compteur
	ld	hl,#_cnt + 0
	ld	(hl), #0x00
00103$:
	ld	iy, #_cnt
	ld	a, 0 (iy)
	sub	a, #0x1e
	ret	NC
	inc	0 (iy)
;/media/4TB_BACKUP/ZAZDISK_D/Proj/Bidouilleur/PRO-83_Plateforme_Z80/Programmes/SDCC/Horloge.c:102: }
	jr	00103$
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
